package org.xdoclet.plugin.portlet.qtags;

import org.generama.MetadataProvider;

public class TagLibrary {
    public static final String PORTLET_LOCALE = PortletLocaleTagImpl.NAME;
    public static final String PORTLET_PORTLET_INFO = PortletPortletInfoTagImpl.NAME;
    public static final String PORTLET_PORTLET_INIT_PARAM = PortletPortletInitParamTagImpl.NAME;
    public static final String PORTLET_PORTLET = PortletPortletTagImpl.NAME;
    public static final String PORTLET_PREFERENCES = PortletPreferencesTagImpl.NAME;
    public static final String PORTLET_PREFERENCES_VALIDATOR = PortletPreferencesValidatorTagImpl.NAME;
    public static final String PORTLET_RESOURCE_BUNDLE = PortletResourceBundleTagImpl.NAME;
    public static final String PORTLET_SUPPORTS = PortletSupportsTagImpl.NAME;

    public TagLibrary(MetadataProvider metadataProvider) {
        metadataProvider.getDocletTagFactory().registerTag(PortletLocaleTagImpl.NAME, PortletLocaleTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(PortletPortletInfoTagImpl.NAME, PortletPortletInfoTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(PortletPortletInitParamTagImpl.NAME, PortletPortletInitParamTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(PortletPortletTagImpl.NAME, PortletPortletTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(PortletPreferencesTagImpl.NAME, PortletPreferencesTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(PortletPreferencesValidatorTagImpl.NAME, PortletPreferencesValidatorTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(PortletResourceBundleTagImpl.NAME, PortletResourceBundleTagImpl.class);
        metadataProvider.getDocletTagFactory().registerTag(PortletSupportsTagImpl.NAME, PortletSupportsTagImpl.class);
    }
}
